<?php

namespace WPDesk\ShopMagicCart\Placeholder;

use WPDesk\ShopMagic\Placeholder\BasicPlaceholder;
use WPDesk\ShopMagicCart\Cart\Cart;

abstract class CartBasedPlaceholder extends BasicPlaceholder {
	final public function get_required_data_domains(): array {
		return [ Cart::class ];
	}

	final protected function get_cart(): Cart {
		return $this->provided_data[ Cart::class ];
	}

	final protected function is_cart_provided(): bool {
		return isset( $this->provided_data[ Cart::class ] ) && $this->provided_data[ Cart::class ] instanceof Cart;
	}
}
