<?php

declare( strict_types=1 );

namespace WPDesk\ShopMagicCart\Database;

use WPDesk\ShopMagic\Database\Abstraction\Schema\AbstractSchema;

final class DatabaseSchema extends AbstractSchema {
	protected function get_updates(): array {
		return [
			UpdateCartTable::class,
		];
	}

	protected function get_version_option_name(): string {
		return 'shopmagic_cart_db_version';
	}

	protected function get_log_option_name(): string {
		return 'shopmagic_db_log';
	}
}
